/*-------------------------------------------------------------------
   Authors: 2003: Stijn Vansummeren

   The RecordAddress class represents the address of a record
   (i.e. the offset of the block and the index of the record in the
   block).

   $Id: RecordAddress.java,v 1.1.1.1 2005/09/26 08:19:41 stijn Exp $
  -------------------------------------------------------------------*/
package be.ulb.db;

public final class RecordAddress 
{
    private BlockAddress addr;
    private int slot;

    public RecordAddress(BlockAddress addr, int slot)
    {
	this.addr = addr;
	this.slot = slot;
    }

    public int getRecordIndex()
    {
	return slot;
    }

    public BlockAddress getBlockAddress()
    {
	return addr;
    }

    public boolean equals(Object o)
    {
	if (!(o instanceof RecordAddress))
	    return false;
	
	RecordAddress other = (RecordAddress) o;
	return (slot == other.slot && addr.equals(other.addr));
    }

    public boolean isValid()
    {
	return (slot >= 0 && addr != null && addr.isValid());
    }
    
}
