/*-------------------------------------------------------------------
   Authors: 2003: Stijn Vansummeren

   The RecordAddressIterator interface. It provides a means to iterate
   over RecordAddresses. This is for example used by the Index class
   to return all recordaddresses of records having a certain searchkey.

   $Id: RecordAddressIterator.java,v 1.1.1.1 2005/09/26 08:19:41 stijn Exp $
  -------------------------------------------------------------------*/
package be.ulb.db;


import java.io.*;
import java.util.*;

import be.ulb.db.buffermanager.*;
import be.ulb.db.diskmanager.*;
import be.ulb.db.schema.*;

public interface RecordAddressIterator
{
    /* standard iterator stuff */
    public boolean hasNext();
    public RecordAddress next() throws NoSuchElementException , IOException,
				BufferManagerException, DiskManagerException;

    /* closes the attached resources. Calling other methods after a call to close() can fail */
    public void close();
}
