/*-------------------------------------------------------------------
  Authors: 2003: Stijn Vansummeren

  Describes the schema of the records stored in the Relation
  Catalog. This schema consists of the following fields:
  - the name of the relation
  - the address of the block where the relation starts
  - the number of attributes in the relation's schema

  $Id: RelationCatalogSchema.java,v 1.1.1.1 2005/09/26 08:19:41 stijn Exp $
 -------------------------------------------------------------------*/
package be.ulb.db.catalog;

import be.ulb.db.schema.*;


public class RelationCatalogSchema extends Schema
{
    public static final int MAXNAMELENGTH = 25;

    public static final String NAME = "name";
    public static final String ADDR = "addr";
    public static final String ATTRNUM = "attrnum";
	
    public RelationCatalogSchema()
    {
	try {
	    String [] names =  {NAME, ADDR, ATTRNUM};
	    AttributeType [] types = {new AttributeTypeString(25), new AttributeTypeBlockAddress(), new AttributeTypeInt()};
		
	    initSchema(names, types);
	} catch(SchemaException e) {
	    e.printStackTrace();
	    System.exit(1); // it should not occur
	}
    }

    /* statically determine the offset of the attributes */
    public static final int nameIndex = 0;
    public static final int addrIndex = 1;
    public static final int attrNumIndex = 2;
}
