/*-------------------------------------------------------------------
   Authors: 2003: Stijn Vansummeren

   The IndexFactory class provides capabilities to generate a Index.

   IndexFactories are used by the Relation class when it is asked to
   create a new index. For instance when we want to create a new BTree
   Index we do:

   relation.createIndex(keySchema, new BTIndexFactory())
   
   An IndexFactory is meant to be subclassed, a new IndexFactory
   should be created for every new kind of Index.

   $Id: IndexFactory.java,v 1.1.1.1 2005/09/26 08:19:41 stijn Exp $
  -------------------------------------------------------------------*/
package be.ulb.db.index;


import java.nio.*;

import be.ulb.db.buffermanager.*;
import be.ulb.db.schema.*;

public abstract class IndexFactory
{
    /* Subclasses should return a new Index object */
    public abstract Index create(Schema schema, BufferManager bm );
}

