/*-------------------------------------------------------------------
   Authors: 2003: Stijn Vansummeren
   
   The IndexLoader class creates a new instance of an
   Index descendant, given the descendants class name.

   $Id: IndexLoader.java,v 1.1.1.1 2005/09/26 08:19:41 stijn Exp $
   -------------------------------------------------------------------*/
package be.ulb.db.index;


import java.nio.*;
import java.lang.reflect.*;

import be.ulb.db.*;
import be.ulb.db.buffermanager.*;
import be.ulb.db.schema.*;

public class IndexLoader
{
    @SuppressWarnings("unchecked")
	public static Index load(String className, Schema keyschema, BufferManager bm, BlockAddress root)
    {
	try {
	    //make sure the class is loaded into memory
	    Class attrtypeclass = Class.forName(className);

	    Class [] cargs = { Schema.class, BufferManager.class, BlockAddress.class };
	    Constructor c = attrtypeclass.getConstructor(cargs);
	    Object [] oargs = { keyschema, bm, root };
	    return (Index) c.newInstance(oargs);
	}
	catch(Exception e) {
	    System.out.println("Error while creating Index " + className);
	    e.printStackTrace();
	    System.exit(1);
	}

	return null;
    }
}
